package otests.mathtools.Bisection;

import opale.mathtools.*;
import opale.tools.OTest;

public class Bisection implements OTest
{
public void run(String path)
	{
	opale.mathtools.Bisection solve = new opale.mathtools.Bisection();
	System.err.println("1) This test case is a good example of bisection's method. F(x) = x*x-2 has an unique root (sqrt(2)) between 0 and 2.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return x*x-2;
					}
					}
					,0,2)); 
	System.out.println("NITER = "+solve.NITER);

	System.err.println("\n2) In this test case the bisection's method converges to a singularity.\n F(x) = 1/(x-2) and 2 is a singularity of the function.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return 1/(x-2);
					}
					}
					,1,3)); 
	System.out.println("NITER = "+solve.NITER);

	System.err.println("\n3) In this test case the function F(x) = sin(50*x)/x has many root between 0 and 2. It's difficult to know the root computed by the bisection's method.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return Math.sin(x*50)/x;
					}
					}
					,0,2)); 
	System.out.println("NITER = "+solve.NITER);


	System.err.println("\n4) In this test case the bisection's method doesn't converge because the function (x-2)*(x-2) has a double root 2 but doesn't change of sign.");
	System.out.println("ROOT = "+solve.find(
				new IyFx() {
					public double val(double x)
					{
					return (x-2)*(x-2);
					}
					}
					,1,3)); 
	System.out.println("NITER = "+solve.NITER);

	}

public void stop() {};
}
